/*
 *
 *  Copyright (C) 2007  Uwe Weng
 *
 *  This file is part of Fuzzy Services, a library for processing fuzzy
 *  information.
 *
 *  Fuzzy Services are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Fuzzy Services are distributed in the hope that they will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Fuzzy Services; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  The license is also available at http://www.gnu.org/licenses/gpl.txt
 *
 ******************************************************************************/
package net.sourceforge.fuzzyservices.swing;

import org.jdesktop.application.Action;


/**
 *
 * @author Uwe Weng
 */
public class FactDialog extends javax.swing.JDialog {
    // End of variables declaration//GEN-END:variables
    /** Bound property name for <code>model</code>. */
    public static final String MODEL_PROPERTY = "model";

    // Variables declaration - do not modify//GEN-BEGIN:variables
    javax.swing.JPanel buttonPanel;
    javax.swing.JButton cancelButton;
    javax.swing.JLabel crispValueLabel;
    javax.swing.JTextField crispValueTextField;
    javax.swing.JPanel jPanel1;
    javax.swing.JPanel jPanel2;
    javax.swing.JPanel jPanel3;
    javax.swing.JPanel jPanel4;
    javax.swing.JComboBox linguisticTermComboBox;
    javax.swing.JLabel linguisticTermLabel;
    net.sourceforge.fuzzyservices.swing.MembershipFunctionPanel membershipFunctionPanel;
    net.sourceforge.fuzzyservices.swing.MembershipFunctionTableEditorPanel membershipFunctionTableEditorPanel1;
    javax.swing.JButton okButton;
    javax.swing.JPanel valuePanel;
    private FactModel model = new DefaultFactModel();

    /** Creates new form FactDialog
     * @param parent parent of this component
     * @param modal modal property
     */
    public FactDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** Creates new form FactDialog
     * @param parent parent of this component
     * @param modal modal property
     * @param model model for this component
     */
    public FactDialog(java.awt.Frame parent, boolean modal, FactModel model) {
        this(parent, modal);
        setModel(model);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonPanel = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        membershipFunctionTableEditorPanel1 = new net.sourceforge.fuzzyservices.swing.MembershipFunctionTableEditorPanel();
        valuePanel = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        linguisticTermLabel = new javax.swing.JLabel();
        linguisticTermComboBox = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        crispValueLabel = new javax.swing.JLabel();
        crispValueTextField = new javax.swing.JTextField();
        membershipFunctionPanel = new net.sourceforge.fuzzyservices.swing.MembershipFunctionPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        buttonPanel.setName("buttonPanel"); // NOI18N
        buttonPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(mydesktopapplication.MyDesktopApplication.class)
                                                                              .getContext()
                                                                              .getActionMap(FactDialog.class,
                this);
        okButton.setAction(actionMap.get("ok")); // NOI18N
        okButton.setName("okButton"); // NOI18N
        buttonPanel.add(okButton);

        cancelButton.setAction(actionMap.get("cancel")); // NOI18N
        cancelButton.setName("cancelButton"); // NOI18N
        buttonPanel.add(cancelButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.PAGE_END);

        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel2.setName("jPanel2"); // NOI18N
        jPanel2.setLayout(new java.awt.BorderLayout());

        membershipFunctionTableEditorPanel1.setName(
            "membershipFunctionTableEditorPanel1"); // NOI18N
        jPanel2.add(membershipFunctionTableEditorPanel1,
            java.awt.BorderLayout.PAGE_END);

        valuePanel.setName("valuePanel"); // NOI18N
        valuePanel.setLayout(new java.awt.BorderLayout());

        jPanel3.setName("jPanel3"); // NOI18N
        jPanel3.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        linguisticTermLabel.setLabelFor(linguisticTermComboBox);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(mydesktopapplication.MyDesktopApplication.class)
                                                                                               .getContext()
                                                                                               .getResourceMap(FactDialog.class);
        linguisticTermLabel.setText(resourceMap.getString(
                "linguisticTermLabel.text")); // NOI18N
        linguisticTermLabel.setName("linguisticTermLabel"); // NOI18N
        jPanel3.add(linguisticTermLabel);

        linguisticTermComboBox.setModel(new javax.swing.DefaultComboBoxModel(
                new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        linguisticTermComboBox.setAction(actionMap.get(
                "selectLinguisticTermAsValue")); // NOI18N
        linguisticTermComboBox.setName("linguisticTermComboBox"); // NOI18N
        jPanel3.add(linguisticTermComboBox);

        valuePanel.add(jPanel3, java.awt.BorderLayout.PAGE_END);

        jPanel4.setName("jPanel4"); // NOI18N
        jPanel4.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        crispValueLabel.setLabelFor(crispValueTextField);
        crispValueLabel.setText(resourceMap.getString("crispValueLabel.text")); // NOI18N
        crispValueLabel.setName("crispValueLabel"); // NOI18N
        jPanel4.add(crispValueLabel);

        crispValueTextField.setColumns(10);
        crispValueTextField.setAction(actionMap.get("setValue")); // NOI18N
        crispValueTextField.setName("crispValueTextField"); // NOI18N
        jPanel4.add(crispValueTextField);

        valuePanel.add(jPanel4, java.awt.BorderLayout.PAGE_START);

        jPanel2.add(valuePanel, java.awt.BorderLayout.PAGE_START);

        jPanel1.add(jPanel2, java.awt.BorderLayout.PAGE_END);

        membershipFunctionPanel.setName("membershipFunctionPanel"); // NOI18N
        jPanel1.add(membershipFunctionPanel, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    } // </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        java.awt.EventQueue.invokeLater(new Runnable() {
                public final void run() {
                    FactDialog dialog = new FactDialog(new javax.swing.JFrame(),
                            true);
                    dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                            public final void windowClosing(
                                java.awt.event.WindowEvent e) {
                                System.exit(0);
                            }
                        });
                    dialog.setVisible(true);
                }
            });
    }

    @Action
    public final void ok() {
    }

    @Action
    public final void cancel() {
    }

    @Action
    public final void selectLinguisticTermAsValue() {
    }

    @Action
    public final void setValue() {
    }

    /**
     * Defines a new model for this component.
     * @param model The new value for the property.
     * @see #getModel
     */
    public final void setModel(FactModel model) {
        FactModel oldModel = this.model;
        this.model = model;
        firePropertyChange(MODEL_PROPERTY, oldModel, model);
    }

    /**
     * Returns the model of this component.
     * @return the <code>model</code> property
     * @see #setModel
     */
    public FactModel getModel() {
        return model;
    }
}
