/*
 *
 *  Copyright (C) 2007  Uwe Weng
 *
 *  This file is part of Fuzzy Services, a library for processing fuzzy
 *  information.
 *
 *  Fuzzy Services are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Fuzzy Services are distributed in the hope that they will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Fuzzy Services; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  The license is also available at http://www.gnu.org/licenses/gpl.txt
 *
 ******************************************************************************/
package net.sourceforge.fuzzyservices.swing;

import org.jdesktop.application.Action;


/**
 *
 * @author Uwe Weng
 */
public class LinguisticVariableDialog extends javax.swing.JDialog {
    // End of variables declaration//GEN-END:variables
    /** Bound property name for <code>model</code>. */
    public static final String MODEL_PROPERTY = "model";

    // Variables declaration - do not modify//GEN-BEGIN:variables
    javax.swing.JButton addButton;
    javax.swing.JPanel buttonPanel;
    javax.swing.JButton cancelButton;
    javax.swing.JButton clearButton;
    javax.swing.JPanel editButtonPanel;
    javax.swing.JPanel editPanel;
    javax.swing.JPanel linguisticTermPanel;
    net.sourceforge.fuzzyservices.swing.LinguisticVariablePanel linguisticVariablePanel1;
    net.sourceforge.fuzzyservices.swing.LinguisticVariableTabbedPane linguisticVariableTabbedPane;
    javax.swing.JButton okButton;
    javax.swing.JButton removeButton;
    javax.swing.JButton renameButton;
    private LinguisticVariableModel model = new DefaultLinguisticVariableModel();

    /** Creates new form LinguisticVariableDialog
     * @param parent parent of this component
     * @param modal modal property
     */
    public LinguisticVariableDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** Creates new form LinguisticVariableDialog
     * @param parent parent of this component
     * @param modal modal property
     * @param model model for this component
     */
    public LinguisticVariableDialog(java.awt.Frame parent, boolean modal,
        LinguisticVariableModel model) {
        this(parent, modal);
        setModel(model);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonPanel = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        editPanel = new javax.swing.JPanel();
        linguisticTermPanel = new javax.swing.JPanel();
        editButtonPanel = new javax.swing.JPanel();
        addButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        clearButton = new javax.swing.JButton();
        renameButton = new javax.swing.JButton();
        linguisticVariableTabbedPane = new net.sourceforge.fuzzyservices.swing.LinguisticVariableTabbedPane();
        linguisticVariablePanel1 = new net.sourceforge.fuzzyservices.swing.LinguisticVariablePanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(mydesktopapplication.MyDesktopApplication.class)
                                                                                               .getContext()
                                                                                               .getResourceMap(LinguisticVariableDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N

        buttonPanel.setName("buttonPanel"); // NOI18N
        buttonPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(mydesktopapplication.MyDesktopApplication.class)
                                                                              .getContext()
                                                                              .getActionMap(LinguisticVariableDialog.class,
                this);
        okButton.setAction(actionMap.get("ok")); // NOI18N
        okButton.setName("okButton"); // NOI18N
        buttonPanel.add(okButton);

        cancelButton.setAction(actionMap.get("cancel")); // NOI18N
        cancelButton.setName("cancelButton"); // NOI18N
        buttonPanel.add(cancelButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.PAGE_END);

        editPanel.setName("editPanel"); // NOI18N
        editPanel.setLayout(new java.awt.BorderLayout());

        linguisticTermPanel.setName("linguisticTermPanel"); // NOI18N
        linguisticTermPanel.setLayout(new java.awt.BorderLayout());

        editButtonPanel.setName("editButtonPanel"); // NOI18N

        addButton.setAction(actionMap.get("addLinguisticTerm")); // NOI18N
        addButton.setName("addButton"); // NOI18N

        removeButton.setAction(actionMap.get("removeSelectedLinguisticTerm")); // NOI18N
        removeButton.setName("removeButton"); // NOI18N

        clearButton.setAction(actionMap.get("clearLinguisticVariable")); // NOI18N
        clearButton.setName("clearButton"); // NOI18N

        renameButton.setAction(actionMap.get("renameLinguisticTerm")); // NOI18N
        renameButton.setName("renameButton"); // NOI18N

        javax.swing.GroupLayout editButtonPanelLayout = new javax.swing.GroupLayout(editButtonPanel);
        editButtonPanel.setLayout(editButtonPanelLayout);
        editButtonPanelLayout.setHorizontalGroup(editButtonPanelLayout.createParallelGroup(
                javax.swing.GroupLayout.Alignment.LEADING)
                                                                      .addGroup(editButtonPanelLayout.createSequentialGroup()
                                                                                                     .addContainerGap()
                                                                                                     .addGroup(editButtonPanelLayout.createParallelGroup(
                        javax.swing.GroupLayout.Alignment.LEADING)
                                                                                                                                    .addComponent(removeButton,
                        javax.swing.GroupLayout.DEFAULT_SIZE,
                        javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                                                                                    .addComponent(clearButton)
                                                                                                                                    .addComponent(renameButton,
                        javax.swing.GroupLayout.DEFAULT_SIZE,
                        javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                                                                                    .addComponent(addButton,
                        javax.swing.GroupLayout.DEFAULT_SIZE, 71,
                        Short.MAX_VALUE)).addContainerGap(12, Short.MAX_VALUE)));
        editButtonPanelLayout.setVerticalGroup(editButtonPanelLayout.createParallelGroup(
                javax.swing.GroupLayout.Alignment.LEADING)
                                                                    .addGroup(editButtonPanelLayout.createSequentialGroup()
                                                                                                   .addContainerGap()
                                                                                                   .addComponent(addButton,
                    javax.swing.GroupLayout.DEFAULT_SIZE,
                    javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                                                   .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                                                   .addComponent(removeButton,
                    javax.swing.GroupLayout.DEFAULT_SIZE,
                    javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                                                   .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                                                   .addComponent(clearButton)
                                                                                                   .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                                                   .addComponent(renameButton,
                    javax.swing.GroupLayout.DEFAULT_SIZE,
                    javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                                                   .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE,
                    Short.MAX_VALUE)));

        linguisticTermPanel.add(editButtonPanel, java.awt.BorderLayout.EAST);

        linguisticVariableTabbedPane.setName("linguisticVariableTabbedPane"); // NOI18N
        linguisticTermPanel.add(linguisticVariableTabbedPane,
            java.awt.BorderLayout.CENTER);

        editPanel.add(linguisticTermPanel, java.awt.BorderLayout.PAGE_END);

        linguisticVariablePanel1.setName("linguisticVariablePanel1"); // NOI18N
        editPanel.add(linguisticVariablePanel1, java.awt.BorderLayout.CENTER);

        getContentPane().add(editPanel, java.awt.BorderLayout.CENTER);

        pack();
    } // </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        java.awt.EventQueue.invokeLater(new Runnable() {
                public final void run() {
                    LinguisticVariableDialog dialog = new LinguisticVariableDialog(new javax.swing.JFrame(),
                            true);
                    dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                            public final void windowClosing(
                                java.awt.event.WindowEvent e) {
                                System.exit(0);
                            }
                        });
                    dialog.setVisible(true);
                }
            });
    }

    @Action
    public final void cancel() {
    }

    @Action
    public final void ok() {
    }

    /**
     * Defines a new model for this component.
     * @param model The new value for the property.
     * @see #getModel
     */
    public final void setModel(LinguisticVariableModel model) {
        LinguisticVariableModel oldModel = this.model;
        this.model = model;
        firePropertyChange(MODEL_PROPERTY, oldModel, model);
    }

    /**
     * Returns the model of this component.
     * @return the <code>model</code> property
     * @see #setModel
     */
    public LinguisticVariableModel getModel() {
        return model;
    }

    @Action
    public final void renameLinguisticTerm() {
    }

    @Action
    public final void clearLinguisticVariable() {
    }

    @Action
    public final void removeSelectedLinguisticTerm() {
    }

    @Action
    public final void addLinguisticTerm() {
    }
}
