/*
 *
 *  Copyright (C) 2007  Uwe Weng
 *
 *  This file is part of Fuzzy Services, a library for processing fuzzy
 *  information.
 *
 *  Fuzzy Services are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Fuzzy Services are distributed in the hope that they will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Fuzzy Services; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  The license is also available at http://www.gnu.org/licenses/gpl.txt
 *
 ******************************************************************************/
package net.sourceforge.fuzzyservices.swing;

import org.jdesktop.application.Action;


/**
 *
 * @author Uwe Weng
 */
public class MembershipFunctionTableEditorPanel extends javax.swing.JPanel {
    // End of variables declaration//GEN-END:variables
    /** Bound property name for <code>model</code>. */
    public static final String MODEL_PROPERTY = "model";

    // Variables declaration - do not modify//GEN-BEGIN:variables
    javax.swing.JButton addButton;
    javax.swing.JPanel buttonPanel;
    net.sourceforge.fuzzyservices.swing.MembershipFunctionTable membershipFunctionTable;
    javax.swing.JButton removeButton;
    javax.swing.JScrollPane tableScrollPane;
    private MembershipFunctionModel model = new DefaultMembershipFunctionModel();

    /** Creates new form MembershipFunctionTableEditorPanel */
    public MembershipFunctionTableEditorPanel() {
        super();
        initComponents();
    }

    /** Creates new form MembershipFunctionTableEditorPanel
     * @param model model for this component
     */
    public MembershipFunctionTableEditorPanel(MembershipFunctionModel model) {
        this();
        setModel(model);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonPanel = new javax.swing.JPanel();
        addButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        tableScrollPane = new javax.swing.JScrollPane();
        membershipFunctionTable = new net.sourceforge.fuzzyservices.swing.MembershipFunctionTable();

        setName("Form"); // NOI18N
        setLayout(new java.awt.BorderLayout());

        buttonPanel.setName("buttonPanel"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(mydesktopapplication.MyDesktopApplication.class)
                                                                              .getContext()
                                                                              .getActionMap(MembershipFunctionTableEditorPanel.class,
                this);
        addButton.setAction(actionMap.get("addPoint")); // NOI18N
        addButton.setName("addButton"); // NOI18N

        removeButton.setAction(actionMap.get("removePoint")); // NOI18N
        removeButton.setName("removeButton"); // NOI18N

        javax.swing.GroupLayout buttonPanelLayout = new javax.swing.GroupLayout(buttonPanel);
        buttonPanel.setLayout(buttonPanelLayout);
        buttonPanelLayout.setHorizontalGroup(buttonPanelLayout.createParallelGroup(
                javax.swing.GroupLayout.Alignment.LEADING)
                                                              .addGroup(buttonPanelLayout.createSequentialGroup()
                                                                                         .addContainerGap()
                                                                                         .addGroup(buttonPanelLayout.createParallelGroup(
                        javax.swing.GroupLayout.Alignment.LEADING)
                                                                                                                    .addComponent(addButton,
                        javax.swing.GroupLayout.DEFAULT_SIZE, 71,
                        Short.MAX_VALUE)
                                                                                                                    .addComponent(removeButton,
                        javax.swing.GroupLayout.DEFAULT_SIZE,
                        javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                                                                         .addContainerGap(17,
                    Short.MAX_VALUE)));
        buttonPanelLayout.setVerticalGroup(buttonPanelLayout.createParallelGroup(
                javax.swing.GroupLayout.Alignment.LEADING)
                                                            .addGroup(buttonPanelLayout.createSequentialGroup()
                                                                                       .addComponent(addButton,
                    javax.swing.GroupLayout.DEFAULT_SIZE,
                    javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                                       .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                                       .addComponent(removeButton,
                    javax.swing.GroupLayout.DEFAULT_SIZE,
                    javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                                       .addContainerGap(248,
                    Short.MAX_VALUE)));

        add(buttonPanel, java.awt.BorderLayout.LINE_END);

        tableScrollPane.setName("tableScrollPane"); // NOI18N

        membershipFunctionTable.setModel(new javax.swing.table.DefaultTableModel(
                new Object[][] {
                    { null, null, null, null },
                    { null, null, null, null },
                    { null, null, null, null },
                    { null, null, null, null }
                }, new String[] { "Title 1", "Title 2", "Title 3", "Title 4" }));
        membershipFunctionTable.setName("membershipFunctionTable"); // NOI18N
        tableScrollPane.setViewportView(membershipFunctionTable);

        add(tableScrollPane, java.awt.BorderLayout.CENTER);
    } // </editor-fold>//GEN-END:initComponents

    @Action
    public final void addPoint() {
    }

    @Action
    public final void removePoint() {
    }

    /**
     * Defines a new model for this component.
     * @param model The new value for the property.
     * @see #getModel
     */
    public final void setModel(MembershipFunctionModel model) {
        MembershipFunctionModel oldModel = this.model;
        this.model = model;
        firePropertyChange(MODEL_PROPERTY, oldModel, model);
    }

    /**
     * Returns the model of this component.
     * @return the <code>model</code> property
     * @see #setModel
     */
    public MembershipFunctionModel getModel() {
        return model;
    }
}
